<template>
  <div class="index-group-chat-room">
    <coreHeader width="100%" height="10vh">
      <template #headerContent>
        <div class="group-chat-room-header">
          <div class="deatail-container">
            <img
              src="/Images/tabs/arrow-right.svg"
              v-if="locale == 'fa'"
              alt="ion"
              @click="back"
            />
            <img
              src="/Images/tabs/arrow-left.svg"
              v-else
              alt="ion"
              @click="back"
            />
            <img
              :src="groupAvatar"
              v-if="hasAvatar"
              class="image-avatar"
              alt="image"
              @click="openGroupDetail"
            />
            <div class="avatar" @click="openGroupDetail" v-else>
              {{ groupAvatar }}
            </div>
            <span class="header-title" @click="openGroupDetail">
              {{ groupName }}
            </span>
          </div>
          <div class="more-container">
            <img
              :src="
                currentGroupInfo.activeCall
                  ? '/Images/tabs/video-call-active-white.svg'
                  : '/Images/tabs/video-call-white.svg'
              "
              alt="icon"
              style="width: 27px"
              @click="makeVideoCall"
            />
            <img
              src="/Images/tabs/call-white.svg"
              alt="icon"
              style="width: 19px; margin: 0 15px"
            />
            <img src="/Images/tabs/more.svg" alt="icon" style="width: 5px" />
          </div>
        </div>
      </template>
    </coreHeader>
    <div
      class="messages-container"
      :class="{ 'light-bg': !getCurrentThemeIsDark }"
      ref="groupChatRoomRefrence"
      @scroll="handleScroll"
    >
      <coreLoading v-if="loading" />
      <div v-else>
        <div
          v-if="infiniteLoadingStatus"
          style="
            width: 100%;
            height: 50px;
            display: flex;
            justify-content: center;
            align-items: center;
          "
        >
          <img
            src="/Images/tabs/messages/loading-arrows.svg"
            alt="icon"
            class="infinite-loading"
          />
        </div>
        <messageCard
          v-for="message in currentGroup.messages"
          :key="message.id"
          :messageSenderName="message.name"
          :nickname="message.nickname"
          :senderMessageId="message.from"
          :senderMessagePhoneNumber="message.contact_phone"
          :firstChar="message.firstChar"
          :mtype="message.mtype"
          :messageId="message.guid"
          :message="message.message"
          :time="message.creation_time"
          :groupName="message.title"
          :body="message.body"
          :loading="message.loading"
          :avatar="message.avatar"
          :seen="message.deliverstatus"
          :avatarFlag="message.avatarFlag"
        />
        {{ currentGroupMessages }}
        <!-- <div class="slid-up-animation" v-if="floatingButtonStatus">
          <ion-fab
            @click="scrollToBottom"
            style="margin-bottom: 110px"
            slot="fixed"
            vertical="bottom"
            horizontal="start"
            v-once
          >
            <ion-fab-button color="white">
              <img
                style="width: 20px; height: 20px"
                src="/Images/tabs/arrow-bottom.svg"
                alt="icon"
              />
            </ion-fab-button>
          </ion-fab>
        </div> -->
      </div>
    </div>
    <chatInput @handleScroolToBottom="handleScroolToBottom" />
  </div>
</template>

<script setup>
import { defineAsyncComponent } from 'vue';
import chatInput from '@/components/chats/chatInput.vue';
import coreLoading from '@/components/chats/coreLoading.vue';
import coreHeader from '@/components/desktop/coreHeader.vue';
import groupDetailAndroid from '@/components/chats/modals/android/groupDetail/index.vue';

import { useI18n } from 'vue-i18n';
import { useThemeStore } from '@/store/theme.js';
import groupDetailIos from '@/components/chats/modals/ios/groupDetail/index.vue';
import { useGroupChat } from '@/store/chats/groupChat';
import { useChatInput } from '@/store/chats/chatInput.js';
import { useUserStore } from '@/store/user/user.js';
import { useOverallChatsStore } from '@/store/chats/overall';
import {
  IonPage,
  modalController,
  isPlatform,
  IonFab,
  IonFabButton,
} from '@ionic/vue';
import { computed, onMounted, ref, watch } from 'vue';
import { useVideoCallStore } from '@/store/videoCall/videoCall';

const messageCard = defineAsyncComponent(() =>
  import('@/components/chats/messageCard.vue'),
);

const { locale } = useI18n();
const themeStore = useThemeStore();
const userStore = useUserStore();
const groupChatStore = useGroupChat();
const chatInputStore = useChatInput();
const overallChatsStore = useOverallChatsStore();
const videoCallStore = useVideoCallStore();
const groupChatRoomRefrence = ref(null);
const hasAvatar = ref(false);
const changeMessageFlag = ref(null);
const floatingButtonStatus = ref(false);
const messageCount = ref(0);

const currentGroup = computed(() => groupChatStore.currentGroup);

const groupName = computed(() => {
  if (currentGroupInfo.value.title.length > 12) {
    return `...${currentGroupInfo.value.title.slice(0, 12)}`;
  } else {
    return currentGroupInfo.value.title;
  }
});

const getCurrentThemeIsDark = computed(() => {
  return themeStore.getThemeIsDark;
});

const loading = computed(() => {
  return groupChatStore.loading;
});

const currentGroupInfo = computed(() => {
  return groupChatStore.currentGroup;
});

const groupAvatar = computed(() => {
  if (groupChatStore.currentGroup.avatar == '') {
    hasAvatar.value = false;
    return groupChatStore.currentGroup.title.slice(0, 1).toUpperCase();
  } else {
    hasAvatar.value = true;
    return groupChatStore.currentGroup.avatar;
  }
});

const openGroupDetail = async () => {
  if (!loading.value) {
    const modal = await modalController.create({
      component: isAndroid.value ? groupDetailAndroid : groupDetailIos,
    });

    modal.present();
    const { data, role } = await modal.onWillDismiss();

    if (role === 'cancel') {
    }
  }
};

const handleScroolToBottom = () => {
  const element = groupChatRoomRefrence.value;
  element.scrollTop = element.scrollHeight;
};

const back = () => {
  overallChatsStore.updateGroupChatRoomBadge(
    groupChatStore.currentGroup.group_id,
  );
  groupChatStore.clearCurrentGroup();
  modalController.dismiss();
  groupChatStore.updateInChatRoomStatus(false);
  chatInputStore.clearMessageSenderInformation;
  chatInputStore.handleUpdateSendMessageFlag('send');
};

const isAndroid = computed(() => {
  return isPlatform('android');
});

const infiniteLoadingStatus = computed(() => {
  return groupChatStore.infiniteLoading;
});

const currentGroupMessages = computed(() => {
  changeMessageFlag.value = groupChatStore.currentGroup.messages.slice(-1);
});

watch(changeMessageFlag, (newValue, oldValue) => {
  if (changeMessageFlag.value[0].from == userStore.userId) {
    groupChatRoom.value.scrollTop = groupChatRoom.value.scrollHeight;
  }
});

const handleScroll = async () => {
  const element = groupChatRoomRefrence.value;
  if (element.scrollTop == 0) {
    if (!infiniteLoadingStatus.value) {
      messageCount.value += 20;
      await groupChatStore.loadMessagesAfterScroll(
        currentGroup.value.group_id,
        messageCount.value,
      );
    }
  }
};

onMounted(async () => {
  messageCount.value = 20;
  groupChatStore.checkActiveCall();
  await groupChatStore.getGroupAvatar(currentGroup.value.group_id);
  setTimeout(async () => {
    groupChatStore.getGroupTitle(currentGroup.value.group_id);
    await groupChatStore.getGroupMembersUid(currentGroup.value.group_id);
    await groupChatStore.loadedCurrentGroupMessages(
      currentGroup.value.group_id,
      messageCount.value,
    );
    overallChatsStore.updateGroupChatRoomBadge(
      groupChatStore.currentGroup.group_id,
    );
  }, 100);
  const handleScrollToBottom = setInterval(() => {
    if (!loading.value) {
      const element = groupChatRoomRefrence.value;
      element.scrollTop = element.scrollHeight;
      setTimeout(() => {
        clearInterval(handleScrollToBottom);
      }, 500);
    }
  }, 1000);
});

const makeVideoCall = () => {
  videoCallStore.makeConferenceInGroup();
};
</script>

<style scoped>
.infinite-loading {
  width: 20px;
  height: 20px;
  animation: 0.9s loading infinite;
}

@keyframes loading {
  0% {
    transform: rotate(0deg);
  }
  100% {
    transform: rotate(360deg);
  }
}
.index-group-chat-room {
  height: 100vh;
  overflow: hidden;
}
.image-avatar {
  width: 55px;
  height: 55px;
  border-radius: 50%;
  margin: 0 10px;
}
.hide-floating-button {
  display: none;
}
.group-chat-room-header {
  width: 100%;
  height: 10vh;
  display: flex;
  align-items: center;
  padding: 0 15px;
}
.group-chat-room-header .deatail-container {
  width: 70%;
  display: flex;
  justify-content: start;
  align-items: center;
}
.group-chat-room-header .more-container {
  width: 150px;
  display: flex;
  justify-content: end;
  align-items: center;
}
.messages-container {
  width: 100%;
  height: 100vh;
  overflow-y: scroll;
  display: flex;
  flex-direction: column;
  padding-top: 10px;
  padding-bottom: 210px;
  scroll-behavior: smooth;
}
.avatar {
  width: 45px;
  height: 45px;
  background: #668de2;
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 22px;
  margin: 0 10px;
}
.header-content {
  display: flex;
  align-items: center;
}

ion-toolbar {
  --min-height: 10vh;
  --max-height: 95px;
}
.toolbar-title {
  font-size: 32px;
}

.header-title {
  color: #fff;
  font-size: 18px;
  font-style: normal;
  line-height: normal;
}

.light-bg {
  background: #e9e8e8;
}
</style>
